function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

import { Module } from './Module';
import { TokenObserver } from '../observers';
export var Manager = /*#__PURE__*/function () {
  function Manager(application) {
    _classCallCheck(this, Manager);

    this.application = application;
    this.observer = new TokenObserver(this.element, this.componentAttribute, this);
    this.modulesBySlug = new Map();
  }

  _createClass(Manager, [{
    key: "schema",
    get: function get() {
      return this.application.schema;
    }
  }, {
    key: "element",
    get: function get() {
      return this.application.element;
    }
  }, {
    key: "componentAttribute",
    get: function get() {
      return this.schema.componentAttribute;
    }
  }, {
    key: "modules",
    get: function get() {
      return Array.from(this.modulesBySlug.values());
    }
  }, {
    key: "start",
    value: function start() {
      this.observer.start();
    }
  }, {
    key: "stop",
    value: function stop() {
      this.observer.stop();
    }
  }, {
    key: "addModule",
    value: function addModule(definition) {
      var noElement = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var args = arguments.length > 2 ? arguments[2] : undefined;
      var slug = definition.slug;
      this.removeModule(slug);
      var module = new Module(this.application, definition, args);
      this.modulesBySlug.set(slug, module); // Init module

      this._initModule(module, noElement);
    }
  }, {
    key: "removeModule",
    value: function removeModule(slug) {
      var module = this.modulesBySlug.get(slug);

      if (module) {
        this.modulesBySlug.delete(slug); // Destroy module

        this._destroyModule(module);
      }
    } // Token observer delegate

  }, {
    key: "elementMatchedToken",
    value: function elementMatchedToken(element, token) {
      this._initModuleBySlug(token, element);
    }
  }, {
    key: "elementUnmatchedToken",
    value: function elementUnmatchedToken(element, token) {
      this._destroyModuleBySlug(token, element);
    } // Contexts

  }, {
    key: "contexts",
    get: function get() {
      return this.modules.reduce(function (contexts, module) {
        return contexts.concat(Array.from(module.contexts));
      }, []);
    } // Private

  }, {
    key: "_initModule",
    value: function _initModule(module, noElement) {
      var elements = this.observer.getElementsMatchingToken(module.slug); // NoElement means no DOM element (so no load and lifecycle)
      // Args are used only for "mix" [no]components

      if (noElement) {
        module.initNoElement(module.slug, module.args);
      } else {
        var _iterator = _createForOfIteratorHelper(elements),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var element = _step.value;
            module.initElement(element, module.args);
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      }
    }
  }, {
    key: "_destroyModule",
    value: function _destroyModule(module) {
      // eslint-disable-line class-methods-use-this
      var contexts = module.contexts;

      var _iterator2 = _createForOfIteratorHelper(contexts),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var element = _step2.value.element;
          module.destroyElement(element);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    }
  }, {
    key: "_initModuleBySlug",
    value: function _initModuleBySlug(slug, element) {
      var module = this.modulesBySlug.get(slug);

      if (module) {
        module.initElement(element, module.args);
      }
    }
  }, {
    key: "_destroyModuleBySlug",
    value: function _destroyModuleBySlug(slug, element) {
      var module = this.modulesBySlug.get(slug);

      if (module) {
        module.destroyElement(element);
      }
    }
  }]);

  return Manager;
}();