function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

import { ElementObserver } from '../observers';
import { IndexedMultimap } from '../multimap';
export var TokenObserver = /*#__PURE__*/function () {
  function TokenObserver(element, attributeName, delegate) {
    _classCallCheck(this, TokenObserver);

    this.attributeName = attributeName;
    this.delegate = delegate;
    this.elementObserver = new ElementObserver(element, this);
    this.tokensByElement = new IndexedMultimap();
  }

  _createClass(TokenObserver, [{
    key: "start",
    value: function start() {
      this.elementObserver.start();
    }
  }, {
    key: "stop",
    value: function stop() {
      this.elementObserver.stop();
    }
  }, {
    key: "refresh",
    value: function refresh() {
      this.elementObserver.refresh();
    }
  }, {
    key: "selector",
    get: function get() {
      return "[".concat(this.attributeName, "]");
    }
  }, {
    key: "getElementsMatchingToken",
    value: function getElementsMatchingToken(token) {
      return this.tokensByElement.getKeysForValue(token);
    } // Delegate

  }, {
    key: "matchElement",
    value: function matchElement(element) {
      return element.hasAttribute(this.attributeName);
    }
  }, {
    key: "matchElementsInTree",
    value: function matchElementsInTree() {
      var tree = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.element;
      var match = this.matchElement(tree) ? [tree] : [];
      var matches = Array.from(tree.querySelectorAll(this.selector));
      return match.concat(matches);
    }
  }, {
    key: "elementMatched",
    value: function elementMatched(element) {
      var newTokens = Array.from(this._readTokenSetForElement(element));

      for (var _i = 0, _newTokens = newTokens; _i < _newTokens.length; _i++) {
        var token = _newTokens[_i];

        this._elementMatchedToken(element, token);
      }
    }
  }, {
    key: "elementUnmatched",
    value: function elementUnmatched(element) {
      var tokens = this._getTokensForElement(element);

      var _iterator = _createForOfIteratorHelper(tokens),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var token = _step.value;

          this._elementUnmatchedToken(element, token);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }, {
    key: "elementAttributeChanged",
    value: function elementAttributeChanged(element) {
      var newTokenSet = this._readTokenSetForElement(element);

      for (var _i2 = 0, _Array$from = Array.from(newTokenSet); _i2 < _Array$from.length; _i2++) {
        var token = _Array$from[_i2];
        this.elementMatched(element, token);
      }

      var _iterator2 = _createForOfIteratorHelper(this._getTokensForElement(element)),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _token = _step2.value;

          if (!newTokenSet.has(_token)) {
            this.elementUnmatched(element, _token);
          }
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    } // Private

  }, {
    key: "_elementMatchedToken",
    value: function _elementMatchedToken(element, token) {
      if (!this.tokensByElement.has(element, token)) {
        this.tokensByElement.add(element, token);

        if (this.delegate.elementMatchedToken) {
          this.delegate.elementMatchedToken(element, token, this.attributeName);
        }
      }
    }
  }, {
    key: "_elementUnmatchedToken",
    value: function _elementUnmatchedToken(element, token) {
      if (this.tokensByElement.has(element, token)) {
        this.tokensByElement.delete(element, token);

        if (this.delegate.elementUnmatchedToken) {
          this.delegate.elementUnmatchedToken(element, token, this.attributeName);
        }
      }
    }
  }, {
    key: "_getTokensForElement",
    value: function _getTokensForElement(element) {
      return this.tokensByElement.getValuesForKey(element);
    }
  }, {
    key: "_readTokenSetForElement",
    value: function _readTokenSetForElement(element) {
      var tokens = new Set();
      var value = element.getAttribute(this.attributeName) || '';

      var _iterator3 = _createForOfIteratorHelper(value.split(/\s+/)),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var token = _step3.value;

          if (token.length) {
            tokens.add(token);
          }
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }

      return tokens;
    }
  }]);

  return TokenObserver;
}();